#ifndef __USER_USB_LIB__
#define __USER_USB_LIB__
/*==============================================================================
    FILE:           user_usb_lib.h

    DESCRIPTION:

    Copyright (c) 2020 Closed Loop Design, LLC

    This software is supplied "AS IS" without any warranties, express, implied
    or statutory, including but not limited to the implied warranties of fitness
    for purpose, satisfactory quality and non-infringement. Closed Loop Design LLC
    extends you a royalty-free right to use, reproduce and distribute this source
    file as well as executable files created using this source file for use with
    Analog Devices SC5xx family processors only. Nothing else gives you
    the right to use this source file.

==============================================================================*/
/*!
 * @file      user_usb_lib.h
 * @brief
 *
 * @details
 *
 *
 *            Copyright (c) 2020 Closed Loop Design, LLC
 *
 *            This software is supplied "AS IS" without any warranties, express, implied
 *            or statutory, including but not limited to the implied warranties of fitness
 *            for purpose, satisfactory quality and non-infringement. Closed Loop Design LLC
 *            extends you a royalty-free right to use, reproduce and distribute this source
 *            file as well as executable files created using this source file for use with
 *            Analog Devices SC5xx family processors only. Nothing else gives you
 *            the right to use this source file.
 *
 */

/**
 * User Initialization function return values
 */
#include <sys/platform.h>
#include "ll_mgr.h"

/**
 * When set to 1 the audio sample rate is set to 48kHz.
 * When set to 0 the audio sample rate is set to 44.1kHz
 */
#define USER_AUDIO_48kHz_SAMPLE_RATE    1

typedef enum
{
    USER_INIT_SUCCESS = 0,    /*!< Initialization successful */
    USER_INIT_ONGOING,        /*!< Initialization in process */
    USER_INIT_FAILED,         /*!< Initialization failed */
} User_Init_Return_Code;

extern User_Init_Return_Code user_usb_lib_init (void);
extern void user_usb_lib_main (void);
extern void user_usb_lib_timer_handler(void *pCBParam, uint32_t Event, void *pArg);
extern void user_usb_lib_low_priority_timer_handler(void *pCBParam, uint32_t Event, void *pArg);
extern void user_usb_lib_rx_term_byte (unsigned char byte);
extern void user_audio_transmit_audio_stream_data (LL_Mgr_Node * p_node);
extern unsigned char user_audio_audio_in_get_num_queued_packets (void);
extern LL_Mgr_Node * user_audio_w_cdc_get_audio_out_data (void);
extern unsigned long user_audio_w_cdc_get_audio_out_data_num_elements (void);


#endif /* __USER_USB_LIB__ */
